Bug 1302075 - ld.bfd segfaults in objalloc_free
ld.bfd segfaults in objalloc_free
Status: CLOSED EOL
Product: Fedora
Classification: Fedora
Component: binutils (Show other bugs)
23
x86_64 Linux
unspecified Severity unspecified
: ---
: ---
Assigned To: Nick Clifton
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2016-01-26 12:39 EST by Uros Bizjak
Modified: 2016-12-20 13:14 EST (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-12-20 13:14:10 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
object files and libraries to trigger segfault (106.15 KB, application/x-gzip)
2016-01-26 12:39 EST, Uros Bizjak
no flags Details


External Trackers
Tracker ID Priority Status Summary Last Updated
GNU Compiler Collection 69408 None None None 2016-01-26 12:39 EST

  None (edit)
Description Uros Bizjak 2016-01-26 12:39:39 EST
Created attachment 1118561 [details]
object files and libraries to trigger segfault

Description of problem:

ld.bfd segfaults with attached object and library with following flags:

ld.bfd --eh-frame-hdr -m elf_x86_64 -dynamic-linker /lib64/ld-linux-x86-64.so.2 -r 20100430-1_0.o libgcov.a

Version-Release number of selected component (if applicable):

$ ld.bfd --version
GNU ld version 2.25-15.fc23

How reproducible:

Always.

Steps to Reproduce:

$ ld.bfd --eh-frame-hdr -m elf_x86_64 -dynamic-linker /lib64/ld-linux-x86-64.so.2 -r 20100430-1_0.o libgcov.a
Segmentation fault (core dumped)

Actual results:

Segmentation fault (core dumped)

Expected results:

Well, linking without segfault.

Additional info:

gdb session:

(gdb) r
Starting program: /usr/bin/ld.bfd --eh-frame-hdr -m elf_x86_64 -dynamic-linker /lib64/ld-linux-x86-64.so.2 -r 20100430-1_0.o libgcov.a

Program received signal SIGSEGV, Segmentation fault.
objalloc_free (o=0x0) at ./objalloc.c:181
181       l = (struct objalloc_chunk *) o->chunks;
(gdb) bt
#0  objalloc_free (o=0x0) at ./objalloc.c:181
#1  0x00007ffff7b0129d in bfd_hash_table_free (table=table@entry=0x555555831be0 <lang_definedness_table>) at hash.c:426
#2  0x0000555555572559 in lang_finish () at ldlang.c:1274
#3  cmdline_emit_object_only_section () at ldlang.c:9004
#4  0x000055555555f583 in main (argc=9, argv=0x7fffffffdc58) at ./ldmain.c:487


FYI, ld.gold works OK with provided flags.
Comment 1 H.J. Lu 2016-01-26 13:56:22 EST
It was caused by binutils-2.25-kernel-ld-r.patch which has been
obsoleted by users/hjl/lto-mixed/master branch.
Comment 2 David Howells 2016-01-27 11:03:28 EST
I tried the testcase above:

 (*) F23 system binutils - the SEGV happens.

 (*) cross-binutils rebased on F24's system binutils-2.26, all patches applied - works (or, at least, doesn't SEGV).

 (*) cross-binutils rebased on F24's system binutils-2.26 with the binutils-2.25-kernel-ld-r.patch and binutils-2.25.1-plugin-format-checking.patch patches removed - works (or, at least, doesn't SEGV).
Comment 3 Fedora End Of Life 2016-11-24 10:13:15 EST
This message is a reminder that Fedora 23 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 23. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '23'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 23 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 4 Fedora End Of Life 2016-12-20 13:14:10 EST
Fedora 23 changed to end-of-life (EOL) status on 2016-12-20. Fedora 23 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.